local mod = ...



-- Fuel need -------------------------------------------------------------------------------------
mod:registerEnumValue( "RESOURCE_TYPE", "FUEL_RESOURCE_TYPE" )
mod:registerAssetId("icons/fuel.png", "ICON_FUEL_NEED", "ATLAS_CELL")

-- Happiness factor
mod:registerAsset({
    DataType = "HAPPINESS_FACTOR",
    Id = "HAPPINESS_FACTOR_FUEL",
    Name = "FUEL_HAPPINESS_FACTOR_NAME",
    Description = "FUEL_NEED_DESC",
    Value = -2,
    IsDecaying = true,
    TimeBeforeDecayingSeconds = 120.0,
    DecayingRatePerMinute = 3.5,
    IsCumulative = true,
    IsSolvable = true,
    RemovedOnDecayed = false,
    Icon = "ICON_FUEL_NEED",
})

-- Villager Need Type
mod:registerAsset({
    DataType = "VILLAGER_NEED_TYPE",
    Id = "FUEL_NEED",
    NeedTypeName = "FUEL_NEED_NAME",
    NeedTypeDescription = "FUEL_NEED_DESC",
    NeedTypeList = {"FUEL_RESOURCE_TYPE"},
    -- FillDurationInSeconds=840, -- 420 seems to be the duration of water and food, 2-3 days
    FillDurationInSeconds = 1000, -- 420 seems to be the duration of water and food, 2-3 days
    FillRate = 100,
    GracePeriod = 7,
    HappinessFactor = "HAPPINESS_FACTOR_FUEL",
    ResourceTypeIcon = "ICON_FUEL_NEED",
})



-- Household Service need -------------------------------------------------------------------------------------

-- Happiness factor
mod:registerAsset({
    DataType = "HAPPINESS_FACTOR",
    Id = "HAPPINESS_FACTOR_SERVANT",
    Name = "HAPPINESS_FACTOR_SERVANT_NAME",
    Description = "HAPPINESS_FACTOR_SERVANT_DESC",
    Value = -2,
    IsDecaying = true,
    TimeBeforeDecayingSeconds = 120.0,
    DecayingRatePerMinute = 3.5,
    IsCumulative = true,
    IsSolvable = true,
    RemovedOnDecayed = false,
    Icon = "ICON_SERVANT",
})

-- Villager Need Type
mod:registerAsset({
    DataType = "VILLAGER_NEED_TYPE",
    Id = "NEED_SERVANT",
    NeedTypeName = "NEED_SERVANT_NAME",
    NeedTypeDescription = "NEED_SERVANT_DESC",
    NeedTypeList = {"RESOURCE_TYPE_SERVANT"},
    FillDurationInSeconds = 420, -- 420 seems to be the duration of water and food, 2-3 days
    FillRate = 100,
    GracePeriod = 7,
    HappinessFactor = "HAPPINESS_FACTOR_SERVANT",
    ResourceTypeIcon = "ICON_SERVANT",
})



-- Entertainment need -------------------------------------------------------------------------------------

-- Icon
mod:registerAssetId("icons/NeedEntertainment.png", "ICON_NEED_ENTERTAINMENT", "ATLAS_CELL")

-- Happiness factor
mod:registerAsset({
    DataType = "HAPPINESS_FACTOR",
    Id = "HAPPINESS_FACTOR_ENTERTAINMENT",
    Name = "NEED_ENTERTAINMENT_NAME",
    Description = "HAPPINESS_FACTOR_ENTERTAINMENT_DESC",
    Value = -2,
    IsDecaying = true,
    TimeBeforeDecayingSeconds = 120.0,
    DecayingRatePerMinute = 3.5, -- default is 2.0
    IsCumulative = true,
    IsSolvable = true,
    RemovedOnDecayed = false,
    Icon = "ICON_NEED_ENTERTAINMENT",
})

-- Villager Need Type
mod:registerAsset({
    DataType = "VILLAGER_NEED_TYPE",
    Id = "NEED_ENTERTAINMENT",
    NeedTypeName = "NEED_ENTERTAINMENT_NAME",
    NeedTypeDescription = "HAPPINESS_FACTOR_ENTERTAINMENT_DESC",
    NeedTypeList = {"ENTERTAINMENT"}, -- this need type already exists in the vanilla game
    FillDurationInSeconds = 1680, -- 420 seems to be the duration of water and food, 2-3 days
    FillRate = 100,
    GracePeriod = 7,
    HappinessFactor = "HAPPINESS_FACTOR_ENTERTAINMENT",
    ResourceTypeIcon = "ICON_NEED_ENTERTAINMENT",
})



-- Monastery Faith -------------------------------------------------------------------------------------

-- Villager Need Type
mod:registerAsset({
    DataType = "VILLAGER_NEED_TYPE",
    Id = "NEED_MONASTERY_FAITH",
    NeedTypeName = "NEED_MONASTERY_FAITH_NAME",
    NeedTypeDescription = "NEED_MONASTERY_FAITH_DESC",
    NeedTypeList = { "RESOURCE_TYPE_MONASTERY_FAITH" },
    FillDurationInSeconds = 420, -- 420 seems to be the duration of water and food, 2-3 days
    FillRate = 100,
    GracePeriod = 7,
    HappinessFactor = "HAPPINESS_FACTOR_LACK_SERVICES",
    ResourceTypeIcon = "ICON_RESOURCE_FAITH",
})



-- Monastery Food -------------------------------------------------------------------------------------

-- Icon
mod:registerAssetId("icons/NeedFood.png", "ICON_NEED_FOOD", "ATLAS_CELL")

-- Villager Need Type
mod:registerAsset({
    DataType = "VILLAGER_NEED_TYPE",
    Id = "NEED_MONASTERY_FOOD",
    NeedTypeName = "NEED_MONASTERY_FOOD_NAME",
    NeedTypeDescription = "NEED_MONASTERY_FOOD_DESC",
    NeedTypeList = { "RESOURCE_TYPE_MONASTERY_FOOD" },
    FillDurationInSeconds = 420, -- 420 seems to be the duration of water and food, 2-3 days
    FillRate = 100,
    GracePeriod = 7,
    HappinessFactor = "HAPPINESS_FACTOR_LACK_FOOD",
    ResourceTypeIcon = "ICON_NEED_FOOD",
})



-- Monastery Clothes -------------------------------------------------------------------------------------

-- Icon
mod:registerAssetId("icons/NeedClothes.png", "ICON_NEED_CLOTHES", "ATLAS_CELL")

-- Villager Need Type
mod:registerAsset({
    DataType = "VILLAGER_NEED_TYPE",
    Id = "NEED_MONASTERY_CLOTHES",
    NeedTypeName = "NEED_MONASTERY_CLOTHES_NAME",
    NeedTypeDescription = "NEED_MONASTERY_CLOTHES_DESC",
    NeedTypeList = { "RESOURCE_TYPE_MONASTERY_CLOTHES" },
    FillDurationInSeconds = (420*3), -- 420 seems to be the duration of water and food, 2-3 days
    FillRate = 100,
    GracePeriod = 7,
    HappinessFactor = "HAPPINESS_FACTOR_LACK_GOODS",
    ResourceTypeIcon = "ICON_NEED_CLOTHES",
})



-- -- Monastery Study -------------------------------------------------------------------------------------

-- -- Icon
-- mod:registerAssetId("icons/NeedStudy.png", "ICON_NEED_STUDY", "ATLAS_CELL")

-- -- Happiness factor
-- mod:registerAsset({
--     DataType = "HAPPINESS_FACTOR",
--     Id = "HAPPINESS_FACTOR_STUDY",
--     Name = "HAPPINESS_FACTOR_STUDY_NAME",
--     Description = "HAPPINESS_FACTOR_STUDY_DESC",
--     Value = -2,
--     IsDecaying = true,
--     TimeBeforeDecayingSeconds = 120.0,
--     DecayingRatePerMinute = 3.5, -- default is 2.0
--     IsCumulative = true,
--     IsSolvable = true,
--     RemovedOnDecayed = false,
--     Icon = "ICON_NEED_STUDY",
-- })

-- -- Villager Need Type
-- mod:registerAsset({
--     DataType = "VILLAGER_NEED_TYPE",
--     Id = "NEED_MONASTERY_STUDY",
--     NeedTypeName = "NEED_MONASTERY_STUDY_NAME",
--     NeedTypeDescription = "NEED_MONASTERY_STUDY_DESC",
--     NeedTypeList = { "RESOURCE_TYPE_MONASTERY_STUDY" },
--     FillDurationInSeconds = (420*2), -- 420 seems to be the duration of water and food, 2-3 days
--     FillRate = 100,
--     GracePeriod = 7,
--     HappinessFactor = "HAPPINESS_FACTOR_STUDY",
--     ResourceTypeIcon = "ICON_NEED_STUDY",
-- })